Bug 1002101 - Review Request: glusterfs-hadoop - GlusterFS Hadoop Compatible File System (HCFS) plugin
Review Request: glusterfs-hadoop - GlusterFS Hadoop Compatible File System (H...
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: gil cattaneo
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-08-28 09:20 EDT by Matthew Farrellee
Modified: 2013-09-03 15:06 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-09-03 15:06:55 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
puntogil: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Matthew Farrellee 2013-08-28 09:20:00 EDT
Spec URL: http://matt.fedorapeople.org/pkg/0/glusterfs-hadoop.spec
SRPM URL: http://matt.fedorapeople.org/pkg/0/glusterfs-hadoop-2.1.2-1.src.rpm
Description:
   A Hadoop Compatible File System (HCFS) plugin for GlusterFS. This
   allows data stored in Gluster to be processed by Hadoop ecosystem
   analytics engines, e.g. MapReduce.
Fedora Account System Username: matt
Comment 1 Matthew Farrellee 2013-08-28 09:23:52 EDT
FYI, building this package requires hadoop-2.0.5-8 because of a pom issue w/ tools.jar.

http://koji.fedoraproject.org/koji/taskinfo?taskID=5864327
Comment 2 gil cattaneo 2013-08-28 09:39:20 EDT
please, remove
mkdir -p %{buildroot} in %install section and

%clean
rm -rf %{buildroot}

why don't use directly https://github.com/gluster/hadoop-glusterfs/archive/%{version}.tar.gz ? have you done some changes to the archive?
Comment 3 Matthew Farrellee 2013-08-28 11:11:35 EDT
If I remove 'mkdir -p %{buildroot}' then the %mvn_install macro will do the wrong thing. Specifically, 'cp -pr .xmvn/root/* $RPM_BUILD_ROOT' when .xmvn/root/usr/share exists will result in $RPM_BUILD_ROOT/share existing, because the 'usr' component actually gets renamed to be the last component of the $RPM_BUILD_ROOT. I'm not sure if this should be considered a bug in mvn_install or not.

I've removed the %clean.

I've made no changes to the archive. I've changed Source0 to use the github link directly.

New spec & SRPM -

Spec URL: http://matt.fedorapeople.org/pkg/1/glusterfs-hadoop.spec
SRPM URL: http://matt.fedorapeople.org/pkg/1/glusterfs-hadoop-2.1.2-1.src.rpm
Comment 4 gil cattaneo 2013-08-28 11:23:58 EDT
(In reply to Matthew Farrellee from comment #3)
> If I remove 'mkdir -p %{buildroot}' then the %mvn_install macro will do the
> wrong thing. Specifically, 'cp -pr .xmvn/root/* $RPM_BUILD_ROOT' when
> .xmvn/root/usr/share exists will result in $RPM_BUILD_ROOT/share existing,
> because the 'usr' component actually gets renamed to be the last component
> of the $RPM_BUILD_ROOT. I'm not sure if this should be considered a bug in
> mvn_install or not.

if this problem happen only on Your system then remove that one.
otherwise report a bug. i never encountered this problem with
java packages tools
regards
Comment 5 Matthew Farrellee 2013-08-28 11:47:11 EDT
(In reply to gil cattaneo from comment #4)
> (In reply to Matthew Farrellee from comment #3)
> > If I remove 'mkdir -p %{buildroot}' then the %mvn_install macro will do the
> > wrong thing. Specifically, 'cp -pr .xmvn/root/* $RPM_BUILD_ROOT' when
> > .xmvn/root/usr/share exists will result in $RPM_BUILD_ROOT/share existing,
> > because the 'usr' component actually gets renamed to be the last component
> > of the $RPM_BUILD_ROOT. I'm not sure if this should be considered a bug in
> > mvn_install or not.
> 
> if this problem happen only on Your system then remove that one.
> otherwise report a bug. i never encountered this problem with
> java packages tools
> regards

I never had it happen on my dev box, only on a pristine F19 VM.

I just tested on a pristine F21 VM with no error.

I've removed the mkdir an updated the spec in place (same urls as comment 3).
Comment 6 gil cattaneo 2013-08-28 18:43:01 EDT
Manual review, Cause hadoop-2.0.5-8.fc21 wasn't available in rawhide
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://fedoraproject.org/wiki/Packaging:Guidelines


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
     Note: Using prebuilt rpms.
[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Fully versioned dependency in subpackages, if present.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in glusterfs-
     hadoop-javadoc
[x]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "Unknown or generated". 7 files have unknown license.
[x]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 30720 bytes in 2 files.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
     Note: Using prebuilt packages
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

Java:
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
     Note: Maven packages do not need to (Build)Require jpackage-utils. It is
     pulled in by maven-local
[x]: Fully versioned dependency in subpackages, if present.
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)
[x]: Bundled jar/class files should be removed before build

Maven:
[x]: If package contains pom.xml files install it (including depmaps) even
     when building with ant
[x]: If tests are skipped during package build explain why it was needed in a
     comment
     Note: Tests seem to be skipped. Verify there is a commment giving a
     reason for this
[x]: Pom files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DOES NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use %{_mavenpomdir} instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[!]: Reviewer should test that the package builds in mock.
[!]: Dist tag is present.
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Installation errors
-------------------
INFO: mock.py version 1.1.33 starting...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
Start: run
Mock Version: 1.1.33
INFO: Mock Version: 1.1.33
Start: lock buildroot
INFO: installing package(s): /home/gil/1002101-glusterfs-hadoop/srpm/glusterfs-hadoop-2.1.2-1.noarch.rpm /home/gil/1002101-glusterfs-hadoop/srpm/glusterfs-hadoop-javadoc-2.1.2-1.noarch.rpm
ERROR: Command failed: 
 # ['/usr/bin/yum', '--installroot', '/var/lib/mock/fedora-19-i386/root/', 'install', '/home/gil/1002101-glusterfs-hadoop/srpm/glusterfs-hadoop-2.1.2-1.noarch.rpm', '/home/gil/1002101-glusterfs-hadoop/srpm/glusterfs-hadoop-javadoc-2.1.2-1.noarch.rpm', '--setopt=tsflags=nocontexts']
Errore: Pacchetto: glusterfs-hadoop-2.1.2-1.noarch (/glusterfs-hadoop-2.1.2-1.noarch)
            Richiede: mvn(org.apache.hadoop:hadoop-common)
 Si può provare ad usare --skip-broken per aggirare il problema
 Provare ad eseguire: rpm -Va --nofiles --nodigest



Rpmlint
-------
Checking: glusterfs-hadoop-2.1.2-1.noarch.rpm
          glusterfs-hadoop-javadoc-2.1.2-1.noarch.rpm
glusterfs-hadoop.noarch: W: spelling-error %description -l en_US analytics -> analytic, analytic s, paralytics
glusterfs-hadoop.noarch: W: no-url-tag
glusterfs-hadoop-javadoc.noarch: W: no-url-tag
2 packages and 0 specfiles checked; 0 errors, 3 warnings.




Requires
--------
glusterfs-hadoop-javadoc (rpmlib, GLIBC filtered):
    jpackage-utils

glusterfs-hadoop (rpmlib, GLIBC filtered):
    java
    jpackage-utils
    mvn(junit:junit)
    mvn(org.apache.hadoop:hadoop-common)
    mvn(org.slf4j:slf4j-api)
    mvn(org.slf4j:slf4j-log4j12)



Provides
--------
glusterfs-hadoop-javadoc:
    glusterfs-hadoop-javadoc

glusterfs-hadoop:
    glusterfs-hadoop
    mvn(org.apache.hadoop.fs.glusterfs:glusterfs)



Source checksums
----------------
https://github.com/gluster/hadoop-glusterfs/archive/2.1.2.tar.gz :
  CHECKSUM(SHA256) this package     : d416552fd9c373a6a25ac072269c6380407e90d2f22ee1654cc486f65458b4f3
  CHECKSUM(SHA256) upstream package : d416552fd9c373a6a25ac072269c6380407e90d2f22ee1654cc486f65458b4f3


Generated by fedora-review 0.4.1 (b2e211f) last change: 2013-04-29
Buildroot used: fedora-19-i386
Command line :/usr/bin/fedora-review -vpn glusterfs-hadoop

PROBLEMs:

[!]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
     Note: Using prebuilt rpms.
mvn(junit:junit)
mvn(org.apache.hadoop:hadoop-common)
mvn(org.slf4j:slf4j-api)
mvn(org.slf4j:slf4j-log4j12)
skip they are used by other libraries during the build ...?

[!]: Changelog in prescribed format.
[!]: Dist tag is present.
release field MUST be
Release: 1%{?dist}

README  file must be installed also in javadoc docdir?
%files javadoc -f .mfiles-javadoc
%doc README COPYING

please, can you add a comment about these BRs?
BuildRequires: mvn(org.codehaus.jackson:jackson-jaxrs)
BuildRequires: mvn(org.znerd:znerd-oss-parent)
Comment 7 Matthew Farrellee 2013-09-01 11:52:53 EDT
Re dist - I've added %{?dist}

Re mock build - hadoop-2.0.5-8 should be available in fc20 and fc21 now
 - http://koji.fedoraproject.org/koji/buildinfo?buildID=459835
 - http://koji.fedoraproject.org/koji/buildinfo?buildID=459834
 - 'fedora-review -n glusterfs-hadoop -m fedora-20-x86_64' worked on 1 Sept 2013
 - FYI, fedora-rawhide-x86_64 was getting 2.0.5-7 and failing

Re README in javadoc - not necessary, I didn't think it would hurt, I've removed it

Re BuildRequires - jackson & znerd
 - They are artifacts of building the package before hadoop was complete, I've removed them

Re Requires - junit and slf4j
 - What do you recommend?

Also, added a url-tag

Spec URL: http://matt.fedorapeople.org/pkg/2/glusterfs-hadoop.spec
SRPM URL: http://matt.fedorapeople.org/pkg/2/glusterfs-hadoop-2.1.2-1.src.rpm
Comment 8 gil cattaneo 2013-09-01 12:35:48 EDT
(In reply to Matthew Farrellee from comment #7)

> Re Requires - junit and slf4j
>  - What do you recommend?
> 
are already required by hadhoop
> Also, added a url-tag
> 
source rpm should be something like that
> SRPM URL: http://matt.fedorapeople.org/pkg/2/glusterfs-hadoop-2.1.2-1.fc19.src.rpm

thanks
Comment 9 gil cattaneo 2013-09-01 13:06:46 EDT
APPROVED
Comment 10 Matthew Farrellee 2013-09-01 13:16:36 EDT
New Package SCM Request
=======================
Package Name: glusterfs-hadoop
Short Description: GlusterFS Hadoop Compatible File System (HCFS) plugin
Owners: matt
Branches: f20
InitialCC:
Comment 11 Kevin Fenzi 2013-09-01 14:28:45 EDT
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.